using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Resources;
using System.Runtime.InteropServices;
using System.Text;

using Microsoft.BizTalk.Component.Interop;
using Microsoft.BizTalk.Message.Interop;

namespace MsmqPropertyPromotionComponent
{
	/// <summary>
	/// Promoter
	/// </summary>
   [ ComponentCategory(CategoryTypes.CATID_PipelineComponent) ]
   [ ComponentCategory(CategoryTypes.CATID_Any) ]
   [ ComponentCategory(CategoryTypes.CATID_Validate) ]
   [ Guid("12832625-696D-4664-B56C-FFCEFC85D1AC") ]
	public class MsmqLabelPromoter :
      IBaseComponent, 
      Microsoft.BizTalk.Component.Interop.IComponent, 
      IComponentUI, 
      IPersistPropertyBag
	{
      private const string VERSION = "1.0";
      private readonly Guid CLSID = new Guid("12832625-696D-4664-B56C-FFCEFC85D1AC");

      public MsmqLabelPromoter()
		{
		}

      #region IBaseComponent Members

      //
      // IBaseComponent Members
      // 

      /// <summary>
      /// Description of the component
      /// </summary>
      [ Browsable(false) ]
      public string Description {
         get { return "Promotes the MSMQ.Label property"; }
      }

      /// <summary>
      /// Name of the component
      /// </summary>
      [ Browsable(false) ]
      public string Name {
         get { return "MSMQ Label Promoter"; }
      }

      /// <summary>
      /// Version of the component
      /// </summary>
      [ Browsable(false) ]
      public string Version {
         get { return VERSION; }
      }

      #endregion // IBaseComponent Members


      #region IComponent Members

      //
      // IComponent Members
      // 

      /// <summary>
      /// Execute the pipeline component
      /// </summary>
      /// <param name="context"></param>
      /// <param name="msg"></param>
      /// <returns></returns>
      public IBaseMessage Execute(IPipelineContext context, IBaseMessage msg)
      {
         MSMQ.Label labelProp = new MSMQ.Label();
         object obj = msg.Context.Read(labelProp.Name.Name, labelProp.Name.Namespace); 
         string label = obj as string;
         if ( label != null )
         {
            msg.Context.Promote(labelProp.Name.Name, labelProp.Name.Namespace, label);
         }
         return msg;
      }

      #endregion // IComponent Members


      #region IComponentUI Members
      //
      // IComponentUI Members
      //

      /// <summary>
      /// Icon to present to the user
      /// </summary>
      [ Browsable(false) ]
      public IntPtr Icon {
         get { return IntPtr.Zero; }
      }

      
      /// <summary>
      /// Validate the configuration to see if it's valid.
      /// Not implemented yet.
      /// </summary>
      /// <param name="projectSystem"></param>
      /// <returns></returns>
      public IEnumerator Validate(object projectSystem)
      {
         return null;
      }


      #endregion // IComponentUI Members


      #region IPersistPropertyBag Members
      //
      // IPersistPropertyBag Members
      //

      /// <summary>
      /// Not necessary, Not implemented
      /// </summary>
      public void InitNew()
      {
      }

      /// <summary>
      /// Get the component Class ID
      /// </summary>
      /// <param name="classID">Class ID of this component</param>
      public void GetClassID(out Guid classID)
      {
         classID = CLSID;
      }

      public void Load(IPropertyBag propertyBag, int errorLog)
      {
      }

      public void Save(IPropertyBag propertyBag, bool clearDirty, bool saveAllProperties)
      {
      }

      #endregion // IPersistPropertyBag Members




	} // class MsmqLabelPromoter

} // namespace MsmqPropertyPromotionComponent
